
import sys
from PyQt4 import QtGui, QtCore

class MainWin(QtGui.QWidget):
    """
        A widget with a list view and a graphics view
    """
    def __init__(self):
        QtGui.QWidget.__init__(self)
        layout = QtGui.QHBoxLayout()
        
        #list view
        self.listwidge = QtGui.QListWidget()
        layout.addWidget(self.listwidge)
        
        #graphics view
        self.gv = MyView()
        layout.addWidget(self.gv)
        
        self.connect(self.listwidge,QtCore.SIGNAL("itemClicked(QListWidgetItem *)"),self.updatePicture)
        
        self.setLayout(layout)
        
        #get image files
        
        files = QtGui.QFileDialog.getOpenFileNames()
        
        self.listwidge.addItems(files)
        
        #create a dictionary of {filename:Qpixmap}
        self.mm = {}
        for item in files:
            new_item = QtGui.QPixmap(item)
            self.mm[str(item)]=new_item
            
    def updatePicture(self,qli):
        """
            use a filename to get the appropriate qimage
        """
        qpix = self.mm[str(qli.text())]
        self.gv.updatePicture(qpix)
        
class MyView(QtGui.QGraphicsView):
    def __init__(self):
        QtGui.QGraphicsView.__init__(self)
        self.scene = QtGui.QGraphicsScene(self)
        
        #current item
        self.item = QtGui.QGraphicsEllipseItem(20, 20, 40, 20)
        self.item.setPos(20,20)
        
        self.scene.addItem(self.item)
        self.setScene(self.scene)
        
    def updatePicture(self,qpix):
        self.scene.removeItem(self.item)
        self.item = QtGui.QGraphicsPixmapItem(qpix)
        self.scene.addItem(self.item)
        
if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    view = MainWin()
    view.show()
    sys.exit(app.exec_())

